UNIT mTSpielmanager;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTRateZahlVerwalter, mTZahlenAusdenker, mTVersuchsZaehler;

//--------------------  ggf Uses-Liste einfgen !  --------------------
//uses ....;
//uses mTZahlenAusdenker ??
//uses mTRateZahlVerwalter ??
//uses mTZaehler ??

type
   TSpielmanager = CLASS

     // weitere Attribute
     private
        FBotschaft : string;
        RateZahlVerwalter : TRateZahlVerwalter;
        Zaehler : TVersuchsZaehler;
        ZahlenAusdenker : TZahlenAusdenker;

     // weitere Methoden
     private
        procedure SetBotschaft(s:string);
     public
        procedure neuesSpiel;
        procedure reagiere_auf_Tipp(r : integer);
        procedure SetRateZahlVerwalter(a:TRateZahlVerwalter);
        procedure SetZaehler(a:TVersuchsZaehler);
        procedure SetZahlenAusdenker(a:TZahlenAusdenker);
        function GetBotschaft : string;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSpielmanager: Methodendefinition 
//+---------------------------------------------------------------------

//-------- SetBotschaft (private) --------------------------------------
procedure TSpielmanager.SetBotschaft(s:string);
begin
  FBotschaft := s;
end;

//-------- neuesSpiel (public) -----------------------------------------
procedure TSpielmanager.neuesSpiel;
begin
  Zaehler.Reset;
  ZahlenAusdenker.neueZahl;
  SetBotschaft('');
end;

//-------- reagiere_auf_Tipp (public) ----------------------------------
procedure TSpielmanager.reagiere_auf_Tipp(r : integer);
var
  g : integer;
  b : string; 
begin
  Zaehler.Inc;
  RateZahlVerwalter.SetZahl(r);
  g := ZahlenAusdenker.GetZahl;
  if r < g
  then
    b := 'RateZahl ist zu klein!'
  else
    if r > g
    then
      b := 'RateZahl ist zu gro!'
    else
      b := 'RateZahl = GeheimZahl!';
  SetBotschaft(b);
end;

//-------- SetRateZahlVerwalter (public) -------------------------------
procedure TSpielmanager.SetRateZahlVerwalter(a:TRateZahlVerwalter);
begin
  RateZahlVerwalter := a;
end;

//-------- SetZaehler (public) -----------------------------------------
procedure TSpielmanager.SetZaehler(a:TVersuchsZaehler);
begin
  Zaehler := a;
end;

//-------- SetZahlenAusdenker (public) ---------------------------------
procedure TSpielmanager.SetZahlenAusdenker(a:TZahlenAusdenker);
begin
  ZahlenAusdenker := a;
end;

//-------- GetBotschaft (public) ---------------------------------------
function TSpielmanager.GetBotschaft : string;
begin
  result := FBotschaft;
end;

end.
