unit uZahlenraten0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  mTSpielmanager, mTRateZahlVerwalter, mTZahlenAusdenker, mTVersuchsZaehler,
  StdCtrls;

type
  TForm1 = class(TForm)
    eRateZahl: TEdit;
    lRateZahl: TLabel;
    bAufTippReagieren: TButton;
    bNeuesSpiel: TButton;
    lVersuche: TLabel;
    lBotschaft: TLabel;
    procedure bAufTippReagierenClick(Sender: TObject);
    procedure bNeuesSpielClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    Spielmanager       : TSpielManager;
    RateZahlVerwalterF : TRateZahlVerwalter;
    ZaehlerF           : TVersuchszaehler;
    ZahlenAusdenkerF   : TZahlenAusdenker;
    procedure aktualisiereGUI;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.aktualisiereGUI;
var
  v : integer;
  b : string;
begin
  v := ZaehlerF.GetZahl;
  b := SpielManager.GetBotschaft;
  lVersuche.Caption := IntToStr(v) + ' Versuche';
  lBotschaft.Caption := b;
end;

procedure TForm1.bAufTippReagierenClick(Sender: TObject);
var
  r : integer;
begin
  r := StrToInt(eRateZahl.Text);
  SpielManager.reagiere_auf_Tipp(r);
  aktualisiereGUI;
end;

procedure TForm1.bNeuesSpielClick(Sender: TObject);
begin
  SpielManager.neuesSpiel;
  aktualisiereGUI;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ZaehlerF := TVersuchsZaehler.Create;
  ZahlenAusdenkerF := TZahlenAusdenker.Create;
  ZahlenAusdenkerF.neueZahl;
  RateZahlVerwalterF := TRateZahlVerwalter.Create;
  SpielManager := TSpielManager.Create;
  SpielManager.SetZaehler(ZaehlerF);
  SpielManager.SetZahlenAusdenker(ZahlenAusdenkerF);
  SpielManager.SetRateZahlVerwalter(RateZahlVerwalterF);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ZaehlerF.Free;
  ZahlenAusdenkerF.Free;
  RateZahlVerwalterF.Free;
  SpielManager.Free;
end;

end.
